import sys
from rhpl import *
import socket
import gettext
_=gettext.gettext
try:
    import gtk
except RuntimeError,e:
    print _("Unable to initialize graphical environment. Most likely cause of failure\n\
is that the tool was not run using a graphical environment. Please either\n\
start your graphical user interface or set your DISPLAY variable. \n\
Caught exception: %s" % e)
    sys.exit(-1)

def idle_func():
    while gtk.events_pending():
        gtk.mainiteration()
        
class Cursor:
    def __init__(self,window):
        self.window=window
        self.busy_cursor = gtk.gdk.Cursor(gtk.gdk.WATCH)
        self.ready_cursor = gtk.gdk.Cursor(gtk.gdk.LEFT_PTR)
        
    def wait(self):
        self.window.set_cursor(self.busy_cursor)
        idle_func()
    
    def ready(self):
        self.window.set_cursor(self.ready_cursor)
        idle_func()
    
import os

PROGNAME='redhat-config-netboot'
VERSION = "0.1.1"
TRUE=1
FALSE=not TRUE
INSTALLDIR="/usr/share/redhat-config-netboot"
PXEBOOTDIR="/tftpboot/linux-install/"
PXECFGDIR=PXEBOOTDIR+"pxelinux.cfg/"

def hostname():
    try:
        return socket.gethostbyname(socket.gethostname())
    except:
        return socket.gethostname()
    
def mkdir(DIR):
    try:
        os.makedirs(DIR)
    except OSError,err:
        if err.errno != 17:
            raise err

def errorMessage(message):
    dlg = gtk.MessageDialog(None, 0, gtk.MESSAGE_ERROR, gtk.BUTTONS_OK,
                            message)
    dlg.show_all()
    rc = dlg.run()
    dlg.destroy()
    return rc
        
def warningMessage(message):
    dlg = gtk.MessageDialog(None, 0, gtk.MESSAGE_WARNING, gtk.BUTTONS_OK,
                            message)
    dlg.show_all()
    rc = dlg.run()
    dlg.destroy()
    return rc
        
def getstatusoutput(cmd):
    """Return (status, output) of executing cmd in a shell."""
    import os
    text=""
    pipe = os.popen('{ ' + cmd + '; } 2>&1', 'r')
    try:
        text = pipe.read()
    except IOError,v:
        text = pipe.read()
        
    sts = pipe.close()
    if sts is None: sts = 0
    if text[-1:] == '\n': text = text[:-1]
    return sts, text
